"{ Package: 'stx:goodies/petitparser/compiler' }"

"{ NameSpace: Smalltalk }"

PPCCompiler subclass:#PPCTokenizingCompiler
	instanceVariableNames:'rememberStrategy'
	classVariableNames:''
	poolDictionaries:''
	category:'PetitCompiler-Core'
!

!PPCTokenizingCompiler methodsFor:'code generation'!

smartRemember: parser to: variableName 
    rememberStrategy smartRemember: parser to: variableName
!

smartRestore: parser from: mementoName
    rememberStrategy smartRestore: parser from: mementoName
! !

!PPCTokenizingCompiler methodsFor:'hooks'!

compiledParserSuperclass
    ^ compiledParserSuperclass ifNil: [ PPTokenizingCompiledParser ]
!

rememberStrategy
    ^ rememberStrategy ifNil: [ PPCCompilerTokenizingRememberStrategy on: self  ]
!

rememberStrategy: whatever
    rememberStrategy := whatever 
! !

!PPCTokenizingCompiler methodsFor:'initialization'!

initialize
    super initialize.
    rememberStrategy := PPCCompilerTokenizingRememberStrategy on: self
! !

!PPCTokenizingCompiler methodsFor:'remember strategy'!

toNormalRememberStrategy
    "
        When backtracking, currentTokenValue and currentTokenType has
        to be restored
    "
    rememberStrategy := PPCCompilerTokenizingRememberStrategy on: self
!

toTokenRememberStrategy
    "
        We dont have to remember currentTokenType and currentTokenValue,
        while parsing token
    "
    rememberStrategy := PPCCompilerTokenRememberStrategy on: self
! !

